
c    Copyright 2003 Lars Ottemoller and Jens Havskov
c
c    This file is part of SEISNET.
c
c    SEISNET is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 2 of the License, or
c    (at your option) any later version.
c
c    Foobar is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with Foobar; if not, write to the Free Software
c    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USa

c$debug
c                                                                               
cccccccccccccccccccccccccccccccccccccccccccccc
c   sep 98 jh     : -----------version 7.0 check----------------------
c                   year 2000, 5 char base name, long file names
c
      program seven
      implicit none
C
C    Seisan library inserts and routines...
C    ======================================
C
       include 'libsei.inc'                ! Open file definitions
       include 'seidim.inc'                ! dimentions
C
       external sei open,                  ! Open file routine.
     &          sei close,                 ! Close file routine.
     &          sei code                   ! Error encoder.
C
C    ============= end of list ==========
C

c-- base
      character*5 ba
c-- time interval chosen          
      CHARACTER*14      START_TIME,END_TIME     
c-- data base name                
      CHARACTER*40      BASE_NAME               
c-- input fron transfer file      
c      character*40      base_or_time            
c-- one line                                            
      character*80	text			
      integer from_eev     ! indicate to routine findevin that call is from eev
c-- unix command
c      character*80 command
c-- event file name               
      character*80      evfile          
c-- ev. selection key             
      character*10      keys                    
c-- event number                  
      integer           event_no,oldno          
c-- status of event search        
      integer           status                  
c logical for existing file or not
c       logical          b_old
c returned code
c       integer          code
c-- new month indicator           
      integer           new_month               
c-- see base                      
      integer           fstart                  
c-- no of phases for one event
c      integer		mstatus			
c-- counter                                                    
      integer		i
c   arguments to eev
      character*80 arg(5)
c   number of arguments
      integer nargs
c-- operator code
c      character*4 operator
c-- dirctory separation character
      character*1 dchar
      real sec      ! seconds
      character *3 ids           ! id status
      character *1 proc_status   ! processing status
	  integer isec
c read unit #1 .. #6
c       integer          read01 

       character*3 month(12)
       data month /'Jan','Feb','Mar','Apr','May',
     * 'Jun','Jul','Aug','Sep','Oct','Nov','Dec'/ 

c
c version
c
       call print_ver 
     & ('SEISNET - seven - version: 2.0.5   date: 06/04/2000')

         write(*,*)
         write(*,*) ' list of commands:'
         write(*,*) ' '
         write(*,*) '     t   - type sfile'
         write(*,*) '     tt  - show sfile name and first line'
         write(*,*) '     e   - edit sfile'
         write(*,*) '     sel - select s-file'
         write(*,*) '     quit '
         write(*,*)


c
c   event number must be zereo before anything has been defined
c
      event_no=0
      oldno=0

c
c   no debugging on file io
c
      b_f_debug$=.false.
      call dir_char(dchar)
      call get_def_base( ba )                 !JAB(BGS)Feb95. Get database.
      write(*,*)                              !JAB(BGS)Feb95.
c
c   get arguments
c
      call get_arguments(nargs,arg)

c
c   data base or index file
c
      if (nargs.eq.1) then
        read(arg(1)(1:4),'(i4)',err=6353) i   ! if a number, must be data base
c
c  assume default data base
c
          base_name(1:5)=ba                    !JAB(BGS)Feb95..default dbase.
          start_time=arg(1)
          goto 6354
c
c  assume index file since one argument and not a number
c
 6353  continue

       write(*,*) 'wrong input'
       stop

 6354 continue
c
c   end time is always to end of month if end time not given or index file
c
      endif
      end_time='            '
c
c   must be a base different from standard or interval
c
      if (nargs.eq.2) then
        start_time=arg(1)
c
c   check if arg2 is a number
c
        read(arg(2)(1:4),'(i4)',err=2736) i
        end_time=arg(2)                     ! assume it was a number        
        base_name(1:5)=ba                   !..default dbase.
        goto 2737
 2736   continue
        base_name=arg(2)                    ! assume 2 argument a data base
 2737   continue
      endif
c
c   must be a base different from standard with an interval
c
      if (nargs.eq.3) then
        start_time=arg(1)
        end_time=arg(2)
        base_name=arg(3)                    ! assume 3 argument a data base
      endif

c
c   get seisan defaults
c
      call get_seisan_def
                                                                              
C                                                                               
C  initial position                                                   
C                                                                               
      call findevin
     *(base_name,start_time,end_time,keys,from_eev,event_no,                             
     *evfile,fstart,new_month,status)
      call put_env_event(evfile)
c                                                                               
C   CHECK IF END OF TIME INTERVAL OR OTHER ERRORS                               
C                                                                               
      IF(STATUS.GT.0) THEN                                                      
         if(status.eq.1) write(6,*)' ***** event not found'                     
         if(status.eq.5) write(6,*)' ***** wrong time interval'                 
c
c   if an empty index file, stop
c
         if(event_no.eq.0.and.status.eq.3) stop
         if(status.eq.9) stop   ! something wrong
      ENDIF                                                                     
c
c
c-------------------------------------------------------                  
c   start of interactive loop                                                   
c-------------------------------------------------------
c

c      write(*,*) ' select s-file for instantaneous data transfer '
c      write(*,*) ' by going to S-file and pressing "w"'
c      write(*,*) ' program works like eev,but has limited functionality'
c      write(*,*)
 10   continue
c
c   open file to get main info
c
      open(1,file=evfile,status='old',err=1818)
      read(1,'(a)',end=1919) text
      goto 1819
c
c   errror
c
 
 1818 continue
      write(6,'(a,i5)')'   ****   Event No ',event_no
      write(6,*)' Event not present in S-file data base, file name is: '
      write(6,'(1x,a)') evfile
      goto 1820
 1820 continue
      keys(1:10)='          '   ! go to next event
      close(1)
      goto 1000
c
 1919 continue
      write(6,'(a,i5)')'   ****   Event No ',event_no
      write(6,'(1x,a)') evfile
      write(6,*)' EMPTY event file'
      text=' '
c
 1819 continue
c
c   find id status
c
      call id_status(1,ids)
c
c   set flag for processing status
c
      proc_status=' '
      if(ids.eq.'NEW'.or.ids.eq.'SPL'.or.ids.eq.'HYP') proc_status='N'
      if(ids.eq.'   ') proc_status='?'   ! unknown status
c
      close(1)
c
C   display info and ask what to do next                                                          
C                                                                               
      read(text(17:20),'(f4.1)',err=1100) sec   ! second
      goto 1101
 1100 continue
      write(6,*)' Something wrong with second in header, set to 00'
      sec=0.0
c
 1101 continue
      isec=sec
      read(text(7:8),'(i2)',err=1300) i   ! month
      if(i.gt.12.or.i.lt.1) then
         write(6,*)' Month wrong in file, fix it !!!'
         write(6,*)' For this event set to month in start time'
         read(start_time(5:6),'(i2)') i
      endif
      goto 1301
 1300 continue
      write(6,*)' Something wrong with month in header, set to 01'
      i=1
 1301 continue

c
c   check for magnitudes, if first not there, see if others
c
      if(text(57:64).eq.'        ') then
         if(text(65:71).ne.'       ') then
            text(57:64)=text(65:71)
         elseif(text(73:79).ne.'       ') then
            text(57:64)=text(73:79)
         endif
      endif
c
c   check what should be in magnitude field
c
      if(text(57:63).eq.'       ') then
         if(text(65:71).ne.'       ') then
           text(57:63)=text(65:71)     ! try 2. magnitude
         else
           text(57:63)=text(73:79)     ! try 3. magnitude
         endif
      endif
c
c   if nothing in magnitude field, put in location agency
c
      if(text(57:63).eq.'       ') then
        text(61:63)=text(46:48)
      endif     

      write(6,289) event_no,
     *text(9:10),             ! day
     *month(i),               ! month
     *text(2:5),              ! year
     *text(12:13),            ! hour
     *text(14:15),            ! min
     *isec,                   ! sec
     *text(21:23),            ! indicators
     *text(24:30),text(31:38),text(39:45), ! hypocenter
     *proc_status,
     *text(52:55),            ! rms
     *text(57:64),                         ! first magnitude
     *text(49:51)                          ! number of stations
 289  format('#',i5,1x,a2,1x,a3,1x,a4,1x,a2,':',a2,1x,i2,1x,
     *a3,a7,a8,a7,a1,a4,1x,a8,1x,a3,'  ? ',$)

c
c   get next action unless given from mulplt
c
      READ(5,'(A10,a)') KEYS


c
c   get here from above if file not there
c   
 1000 continue
c       
c  check if quit                                                                
c       
c      if(keys(1:1).eq.'Q'.or.keys(1:1).eq.'q'.or.keys(1:4).
c     *eq.'quit'.or.keys(1:4).eq.'QUIT') stop                                             

       if(keys(1:1).eq.'Q'.or.keys(1:1).eq.'q') write(*,*) ' try quit'

       if(keys(1:4).eq.'quit'.or.keys(1:4).eq.'QUIT') stop
c
c  find what action to do
c
      call seven_action(base_name,start_time,end_time,keys,
     *event_no,evfile,fstart,
     *from_eev)
c
c   back to ask for next action
c
      goto 10
c
c    end
c
      stop
      end



 
      subroutine seven_action(base_name,start_time,end_time,keys,
     *event_no,evfile,fstart,
     *from_eev)

c
c   routine modified for the action of seven, in eev eev_action
c
      implicit none                                                 
C
C    Seisan library inserts and routines...
C    ======================================
C
       include 'libsei.inc'                ! Open file definitions
       include 'seidim.inc'                ! dimensions
       include 'seisan.inc'
C
       external sei open,                  ! Open file routine.
     &          sei close,                 ! Close file routine.
     &          sei code                   ! Error encoder.
C
C    ============= end of list ==========
C

c-- top directory name
      character*60 top_directory
c-- time interval chosen          
      CHARACTER*14      START_TIME,END_TIME     
c-- data base name                
      CHARACTER*40      BASE_NAME               
c      character*80  wave_file   ! waveform file name
c-- input fron transfer file      
c      character*40      base_or_time            
c-- one line                                            
      character*80	text
c      character*200 txt          
c-- answer
c      character*1 choise
      character*80 eev_edit   ! editor name
      integer sei clen            ! function to get string length
      integer from_eev     ! indicate to routine findevin that call is from eev
c-- unix command
c      character*80 command
c-- event file name               
      character*80      evfile
c      ,oldfile
c-- waveform file name
c      character*80      wavefile
c,directory
c       character*80      directory
c      character*2       new_type   ! new type of event
c      character*1       old_type   ! old type of event
c-- old and new----               
c      character*80      newfile   !,master 
c-- ev. selection key             
      character*10      keys                    
c-- file name printed out         
c      character*80      out_name                
c-- base name to move file to                   
c      character*5       new_base
c-- answer                        
      character*1       answer                  
c-- event id line number
      integer id
c-- operator code
c      character*4 operator
c      character*80 from_mulplt     ! command from mulplt
c      character*1    mulplt_def    ! if O, all default for mulplt plotting

c---time of making update
c      character*12 p_time
c      character*14 proc_time
c-- event number                  
      integer           event_no,current_event_number          
c-- new month indicator           
      integer           new_month               
c-- status of event search        
      integer           status                  
c-- see base                      
      integer           fstart                  
c-- event arrays                  
      character*80      data1(max_data)
c      ,data2(max_data)
c-- no of stations for event                        
      integer		nstat1
c      ,nstat2
c-- no of phases for one event
      integer nphase1
c-- no of records for event                  
      integer     	nrecord1
c      ,nrecord2
c-- no of headers for event                         
      integer		nhead1
c      ,nhead2
c-- event ids--------------               
      character*1       exp1,evid1
c      ,evid2
c      real dist,azim,amp           ! distance and azimuth and amplitude  
c      real strike,dip,rake
c      real hdepth                  ! hypocenter depth
c      real amp_error               ! error in amplitudes for mom tensor
c      real depth(50)
c      ,vp(50)        ! model

c-- number of errors in s-file
      integer nerr
c-- counter                                                    
      integer           i
      
c      logical       loc_append  ! true if appended events only to be located
c      logical b_flag
c      ,exist  ! for input output
c--- logicals for fault plane solution 
c      logical oldfault,newfault
c-- dirctory separation character
      character*1 dchar
c-- indicator of computer used
          logical sun,pc,linux
c logical for end of file
       logical          b_eof
c logical for existing file or not
       logical          b_old
c returned code
       integer          code
c read unit #1 .. #6
       integer          read01
c       , read02, read03
c write unit #1 .. #5
       integer          write01
c       write03, write04
c file name
       character*80     chr_file
c indicator of the use of an index file
c       logical index_file
c       real sec          ! seconds
c       integer isec      ! seconds
c       character*3 month(12)
c       integer hour
c length of the command line to call vi editor, LAA 09.97
       integer leng
c variables for epimap
c       real map_lat_c,map_lon_c
       common/eev/data1,nstat1,nphase1,nrecord1,nhead1,id,exp1,evid1
c       data month /'Jan','Feb','Mar','Apr','May',
c    * 'Jun','Jul','Aug','Sep','Oct','Nov','Dec'/ 

      call topdir(top_directory)
      call dir_char(dchar)
      call computer_type(sun,pc,linux)
c
c   jump data base positioning
c
      goto 15
c
c   back here for data base action before return
c
 10   continue
        
C                                                                               
C  data base action, find next event                                                   
C                                                                               
      call findevin
     *(base_name,start_time,end_time,keys,from_eev,event_no,                             
     *evfile,fstart,new_month,status)

      call put_env_event(evfile)   ! put event file name in memory

c                                                                               
C   CHECK IF END OF TIME INTERVAL OR OTHER ERRORS                               
C                                                                               
      IF(STATUS.GT.0) THEN                                                      
         if(status.eq.1) write(6,*)' ***** event not found'                     
         if(status.eq.5) write(6,*)' ***** wrong time interval'                 

c
cccc the next section is probably not active anymore since variable
c    from_eev prevent status of being 2 or 3
cccc
c
c   if here, assume end of month, status=3 start again
c
c-- begin with first event        
         keys(1:10)='#1        '
         goto 10                                
      ENDIF  
	  return                                                                   
c
c-- continue here at entry to subroutine                      
c
15    continue
c
c
                                                                                
c                                                                               
c   check for lower and upper case                                              
c                                                                               

      if(keys(1:3).eq.'sel') keys(1:3)='SEL'
      if(keys(1:2).eq.'ss') keys(1:2)='SS'
      if(keys(1:1).eq.'t') keys(1:1)='T'                                        
      if(keys(2:2).eq.'t') keys(2:2)='T'                                        
      if(keys(1:1).eq.'e') keys(1:1)='E'                                        

c
c----------------------------------------------------------
c   help
c----------------------------------------------------------
c
      if(keys(1:1).eq.'?') then

         write(*,*) ' list of commands:'
         write(*,*) ' '
         write(*,*) '     t   - type sfile'
         write(*,*) '     tt  - show sfile name and first line'
         write(*,*) '     e   - edit sfile'
         write(*,*) '     sel - select s-file'
         write(*,*) '     quit '
         write(*,*) ' '

         keys(1:4)='SAME'
         goto 10
      endif
c
c-----------------------------------------------------------------------
c  find next new event
c-----------------------------------------------------------------------
c
      if(keys(1:2).eq.'SS') then
         current_event_number=event_no       ! save so search only done once
         keys(1:4)='NEXT'
 1010    continue
         call findevin
     *   (base_name,start_time,end_time,keys,from_eev,event_no,
     *   evfile,fstart,new_month,status)
c
c   check if process has read whole month or base
c
         if(event_no.eq.current_event_number) then
            write(6,*)' No new event found *********************'
            keys(1:4)='SAME'
            goto 10
         endif
c  
         call read_s_file(evfile) 
c
c   check if new event
c
         if((data1(id)(9:11).eq.'NEW'.or.data1(id)(9:11).eq.'SPL'
     *       .or.data1(id)(9:11).eq.'HYP').
     *    and.data1(1)(46:48).ne.'NAO') then
            write(6,*)' New event ------------------------------'
            keys(1:4)='SAME'
            goto 10
         else
            keys(1:4)='NEXT'
            goto 1010
         endif
      endif
            


c------------------------------------------------------------------------
c  editor                                                                       
c-----------------------------------------------------------------------        
      if(keys(1:1).eq.'E') then                                                 

c
c   get editor type
c
         call get_editor(eev_edit)
c        write(6,*) eev_edit
         text = eev_edit(1:sei clen(eev_edit)) // ' ' //
     *     evfile(1:fstart+20)     ! otherwise crash on Solaris lo
 358     continue
         leng = sei clen(text) ! added by LAA, 09.97
         call systemc(text,leng)                             
c
c   read file again to check errors
c
              chr_file = evfile(1:fstart+20)
              call sei open(old$+warn$,            ! Open a existing file.
     &                      ' ',                   ! Prompt file name (n/a).
     &                      chr_file,              ! File name
     &                      write01,               ! Write unit #1
     &                      b_old,                 ! Already exists? (n/a).
     &                      code)                  ! Returned condition
         call indata(write01,nstat1,nphase1,nhead1,
     *   nrecord1,evid1,exp1,data1,id)
         call sei close (close$,write01,code)
c
c   check all fields in s-file
c
c   if output destination eq file (1 or 2), unit number must be changed
         call check_s(data1,                     ! file
     &                nrecord1,                  ! number of records
     &                evfile,                    ! file name
     &                nerr,                      ! number of errors
     &                0,                         ! output destination
     &                0)                         ! unit number
         if(nerr.gt.0) then
            write(6,*)' '
            write(6,*)'  Error in file, return to continue, i to ignore'
            read(5,'(a)')answer
            if(answer(1:1).eq.'i'.or.answer(1:1).eq.'I') goto 3759
            goto 358
         end if
 3759    continue
c
c   check if any id
c
         if(id.eq.0) then
            write(6,*)' No valid ID line, check!!'
            write(6,*)' Return to continue, i to ignore'
            read(5,'(a)')answer 
            if(answer(1:1).eq.'i'.or.answer(1:1).eq.'I') goto 3761
            goto 358
         endif
 3761    continue
         keys(1:4)='SAME'
         goto 10
      endif                                                                     

      if (keys(1:3).eq.'SEL') then

        write(*,*) 's-file selected'
        write(6,'(1x,a,a)') 'File name: ',evfile
        write(*,*) 'FINISHED'
        stop
      endif


c-------------------------------------------------------------------------                                                                               
c   another event                                                               
c-------------------------------------------------------------------------
c      
      if(keys(1:1).eq.' '.or.keys(1:1).eq.'#'.or.
     *   keys(1:1).eq.'d'.or.keys(1:1).eq.'D'.or.
     *   keys(1:1).eq.'1'.or.keys(1:1).eq.'2'.or.keys(1:1).eq.'3'.or.
     *   keys(1:1).eq.'4'.or.keys(1:1).eq.'5'.or.keys(1:1).eq.'6'.or.
     *   keys(1:1).eq.'7'.or.keys(1:1).eq.'8'.or.keys(1:1).eq.'9'.or.
     *   keys(1:1).eq.'0'.or.keys(1:4).eq.'NEXT'.or.
     *   keys(1:4).eq.'next'.or.keys(1:4).eq.'SAME'.or.
     *   keys(1:4).eq.'same') go to 10
c                                                                               
c   back space one event                                                        
c                                                                               
      if(keys(1:1).eq.'B'.or.keys(1:1).eq.'b') then                             
         keys(1:4)='BACK'                                                       
         goto 10                                                                
      endif                                                                     
c
c----------------------------------------------------------------
c   type event                                                                  
c----------------------------------------------------------------          
c
                                                                                
      if(keys(1:1).eq.'t'.or.keys(1:1).eq.'T') then                             
	     i=1
         write(6,*)
         write(6,'(1x,a,a)') 'File name: ',evfile                                               
c        write(6,*)
         chr_file = evfile(1:fstart+20)
         call sei open(old$+warn$,            ! Open a existing file.
     &                      ' ',                   ! Prompt file name (n/a).
     &                      chr_file,              ! File name
     &                      read01,                ! Read unit #1
     &                      b_old,                 ! Already exists? (n/a).
     &                      code)                  ! Returned condition
              if (code .ne. e_ok$) go to 2023
 6       continue                                                               
         read(read01,'(a)',iostat=code) text
         call sei code(fort$,code,read01,b_eof)
         if (b_eof) go to 7
         write(6,'(1x,a79)') text(2:80)                                        
         i=i+1
         if(i.gt.20) then
            write(6,*)' Return to continue, q to return to EEV'
            read(5,'(a)') text
            if(text(1:1).eq.'q'.or.text(1:1).eq.'Q') goto 7
            i=1
         endif
         if(keys(2:2).eq.'T') goto 7   ! only print header line 
         goto 6                                                                 
 7       continue                                                               
         call sei close (close$,read01,code)
         goto 2024                                                              
 2023    continue                                                               
c        write(6,*)' No such file: ',evfile                                     
 2024    continue             
         write(6,*)                                                  
         keys='SAME      '                                                      
         goto 10                                                                
      endif                                                              
c                                                                               
c   stop                                                                        
c                                                                               
      return
      end                                                                       
                                                                                

       subroutine id_status(unit,ids)
c
c   find id line in file opened at unit unit and return status in ids
c
       implicit none
       integer unit,i
       character*3 ids
       character*80 text
c
       ids='   '
       do i=1,10000
         read(unit,'(a)',end=1) text
         if(text(80:80).eq.'I') then
            ids=text(9:11)
            goto 1
         endif
       enddo
c
 1     continue
       return
       end            

      subroutine read_s_file(sfile)

c
c   open and read s-file, close
c
c   see main program for variables
c
      implicit none
      include 'seidim.inc'
      include 'libsei.inc'
      character*80 sfile
      integer read_unit
      logical b_flag
      integer code,nstat,nphase,id,nrecord,nhead
      character*80 data(max_data)
      character*1 exp,type
      common /eev/ data,nstat,nphase,nrecord,nhead,id,exp,type

              call sei open( old$,                 ! Open old file.
     &                  ' ',                  ! No prompt.
     &                  sfile,                ! This file.
     &                  read_unit,            ! On this unit.
     &                  b_flag,
     &                  code )                ! Condition (n/a).
             call indata
     *       (read_unit,nstat,nphase,nhead,nrecord,type,exp,data,id)
             call sei close(close$,read_unit,code)    ! Close (stop on error).
       return
       end
             

                                                                 
